Button = {}
Button.__index = Button

setmetatable(Button, {
    __call = function(cls, ...)
      return cls.new(...)
    end,
   })
 
 function Button.new(x, y, z, sx, sy, color, txt, tx, ty, active, tool, button)
  local self = setmetatable({}, Button)
	self.x = x or 0
	self.y = y or 0
	self.z = z or 0
	self.sx = sx or 0
	self.sy = sy or 0
	self.color = color or {0,0,0,255}
	self.text = {}
	self.text.text = txt or 'B'
	self.text.x = tx or 0
	self.text.y = ty or 0
	self.active = active
	self.tool = tool or 1
	self.button = button or "l"
	return self
 end

function Button:draw()
	love.graphics.rectangle("fill", self.x, self.y, self.sx, self.sy) -- background color of button
	love.graphics.setColor(unpack(self.color)) -- color of the text
	love.graphics.print(self.text.text, self.text.x, self.text.y) -- button text
	love.graphics.rectangle("line", self.x, self.y, self.sx, self.sy) -- outline of the button
	setInterfaceColorDefault()
end

function Button:mousepressed(x, y, button)
	if self.button == button and self.tool == tool and self.active == false then 
		if mouseRange(self.x, (self.x + self.sx), self.y, (self.y + self.sy)) then
			self.active = true
		end
	else
		self.active = false 
	end
end



return Button