
function love.mousepressed(x, y, button)
	if button == "l" then
		mapToggle:mousepressed(x, y, button) -- this is created from the button class and toggles between editor and map
		wireToggle:mousepressed(x, y, button) -- this is also created from the button class and will handle turning wireframe on and off
		if mousex < (imgw * imgscale) then
			mousehold = true
			selection = {{0, 0}, {0, 0}}
			selectionorigin = {0, 0}
			if inimage() then
				if tool == 1 then
					drawpixel(map_layer[layer], math.floor(mousex / imgscale), math.floor(mousey / imgscale), unpack(color))
				elseif tool == 2 then
					--imgdragorigin = {math.floor(mousex-imgdrag[1]), math.floor(mousey-imgdrag[2])}
				elseif tool == 3 then
					selectionorigin = {math.floor(mousex / imgscale), math.floor(mousey / imgscale)}
					
				end
			end
		end
	end
end

function love.mousereleased(x, y, button)
	if button == "l" then
		if zoombuttonover then
			imgscale = imgscale + 1
		elseif zoombutton2over then
			if imgscale > 1 then
				imgscale = imgscale - 1
			end
		elseif toolsbuttonover[1] == true or toolsbuttonover[2] == true or toolsbuttonover[3] == true then
			tool = toolsbuttonovernum
		elseif savebuttonover then
			saveimage()
		elseif tool == 3 then
			savetoclipboard(layer)
		end
		mousehold = false
	elseif button == "r" then
		if inimage() and tool == 1 then -- use the map colors
			local r, g, b, a = imgdata:getPixel(math.floor(mousex / imgscale), math.floor(mousey / imgscale))
			color = {r, g, b, a}
		elseif not inimage() and tool == 1 then -- added by me :) use pallete colors instead of the image 
			color = getPallette(color)
		end
	end
end


function love.keypressed(key)
	if tonumber(key) ~= nil then
		color = colors[tonumber(key)]
	elseif key == "c" or key == "C" then
		savetoclipboard(layer)
	elseif key == "p" or key == "P" and tool ~= 2 then
		if inimage() then
			paste(layer, math.floor(mousex / imgscale), math.floor(mousey / imgscale))
		end
	elseif key == "z"  or key == "z" and tool == 2 then 
		changeMapProperties(true, nil, nil)             -- z key x & y
	elseif key == "x"  or key == "x" and tool == 2 then 
		changeMapProperties(false, nil, nil)			-- x key x & y
	elseif key == "right" and tool == 2 then
		changeMapProperties(true, true, nil) -- right x
	elseif key == "left" and tool == 2 then
		changeMapProperties(false, true, nil) -- left x
	elseif key == "down" and tool == 2 then
		changeMapProperties(true, nil, true) -- down y
	elseif key == "up" and tool == 2 then
		changeMapProperties(false, nil, true) -- up y
	end
end

function buttonstuff()
	zoomplusimg = love.graphics.newImage("images/zoomplus.png")
	zoomminusimg = love.graphics.newImage("images/zoomminus.png")
	zoomimgquad = {}
	zoomimgquad[1] = love.graphics.newQuad(0, 0, 40, 40, 80, 40)
	zoomimgquad[2] = love.graphics.newQuad(40, 0, 40, 40, 80, 40)
	zoombuttonover = false
	zoombutton2over = false
	toolsbuttonimg = love.graphics.newImage("images/toolsbutton.PNG")
	toolsbuttonquad = {}
	for x = 1, 3 do
		toolsbuttonquad[x] = love.graphics.newQuad(82*(x-1), 0, 82, 40, 246, 40)
	end
	toolsbuttonover = {false, false, false}
	toolsbuttonovernum = 1
	savebuttonover = false
end

function mouseoverstuff(dt)
	if mousex > rightPanelGlobalX+5 and mousex < zoomx then
		--print(true)
		if mousey > zoomy and mousey < zoomy+39 then
			zoombuttonover = true
		end
	else
		zoombuttonover = false
	end
	if mousex > zoomx and mousex < zoomx+39 then
		if mousey > zoomy and mousey < zoomy+39 then
			zoombutton2over = true
		end
	else
		zoombutton2over = false
	end
	for i = 1, 3 do
		if mousex > ((rightPanelGlobalX+5)+(28 * (i - 1) ) ) and mousey > zoomy+40 and mousex < (rightPanelGlobalX+5)+(28*i) and mousey < zoomy+80 then
			toolsbuttonover[i] = true
			toolsbuttonovernum = i
		else
			toolsbuttonover[i] = false
		end
	end
	if mousex > rightPanelGlobalX+30 and mousey > rightPanelGlobalY+300 and mousex < rightPanelGlobalX+70 and mousey < rightPanelGlobalY+320 then
		savebuttonover = true
	else
		savebuttonover = false
	end
end



-- execute this in love.update
function moveObjectUpdate(obj)
	if obj.dragging.active then
		obj.x = love.mouse.getX() - obj.dragging.diffX
		obj.y = love.mouse.getY() - obj.dragging.diffY
	end
	return obj
end


-- should be called in love.load
function makeObjectMoveable(obj, X, Y, w, h)
	obj = {
		x = X,
		y = Y,
		width = w,
		height = h,
		dragging = {acitve = false, diffX = 0, diffY = 0}
		
	}
	return obj
end

-- execute inside mouse press maybe keypress too
function controlObjectOnPress(x,y, objbutton, obj)
	if button == objbutton
	and x > obj.x and x < obj.x + obj.width
	and y > obj.y and y < obj.y + obj.height 
	then
		obj.dragging.active = true
		obj.dragging.diffX = x - obj.x
		obj.dragging.diffY = y - obj.y
	end 
end

-- execute inside mouse release or keyrelease
function controlObjectOnRelease(objbutton, obj)
	if button == objbutton then 
		obj.dragging.active = false
	end
end